Module org.apache.sis.metadata
Package org.apache.sis.metadata.iso.distribution

# Class DefaultDataFile

Object
AbstractMetadata
ModifiableMetadata
ISOMetadata
DefaultDataFile

All Implemented Interfaces:
  `Serializable`, `Emptiable`, `LenientComparable`, `IdentifiedObject`, `DataFile`

public class DefaultDataFile extends ISOMetadata implements DataFile
Description of a transfer data file. The following properties are mandatory in a well-formed metadata according ISO 19115:
`MX_DataFile` `├─fileName……………………………………………………………` Name or path of the file. `├─fileDescription…………………………………………` Text description of the data. `└─fileType……………………………………………………………` Format in which the data is encoded.

## Limitations

- Instances of this class are not synchronized for multi-threading. Synchronization, if needed, is caller's responsibility.
- Serialized objects of this class are not guaranteed to be compatible with future Apache SIS releases. Serialization support is appropriate for short term storage or RMI between applications running the same version of Apache SIS. For long term storage, use `XML` instead.

Since:
  0.3
See Also:
  - Serialized Form

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from class ModifiableMetadata

  `ModifiableMetadata​.State`

- ## Field Summary

  ### Fields inherited from class ISOMetadata

  `identifiers`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DefaultDataFile()`
  Constructs an initially empty data file.
  `DefaultDataFile(DataFile object)`
  Constructs a new instance initialized with the values from the specified metadata object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `static DefaultDataFile`
  `castOrCopy(DataFile object)`
  Returns a SIS metadata implementation with the values of the given arbitrary implementation.
  `Collection<LocalName>`
  `getFeatureTypes()`
  Returns the list of feature types concerned by the transfer data file.
  `InternationalString`
  `getFileDescription()`
  Returns the text description of the file.
  `Format`
  `getFileFormat()`
  Deprecated.
  Removed in latest XSD schemas.
  `URI`
  `getFileName()`
  Returns the name or path of the file.
  `String`
  `getFileType()`
  Format in which the file is encoded.
  `void`
  `setFeatureTypes(Collection<? extends LocalName> newValues)`
  Sets the list of feature types concerned by the transfer data file.
  `void`
  `setFileDescription(InternationalString newValue)`
  Sets the text description of the file.
  `void`
  `setFileFormat(Format newValue)`
  Deprecated.
  Removed in latest XSD schemas.
  `void`
  `setFileName(URI newValue)`
  Sets the name or path of the file.
  `void`
  `setFileType(String newValue)`
  Sets the format in which the illustration is encoded.

  ### Methods inherited from class ISOMetadata

  `getIdentifier, getIdentifierMap, getIdentifiers, getStandard, setIdentifier, transitionTo`

  ### Methods inherited from class ModifiableMetadata

  `checkWritePermission, collectionType, copyCollection, copyList, copyMap, copySet, deepCopy, nonNullCollection, nonNullList, nonNullMap, nonNullSet, singleton, state, writeCollection, writeList, writeMap, writeSet`

  ### Methods inherited from class AbstractMetadata

  `asMap, asTreeTable, equals, equals, getInterface, hashCode, isEmpty, prune, toString`

  ### Methods inherited from class Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### DefaultDataFile

    public DefaultDataFile()
    Constructs an initially empty data file.

  - ### DefaultDataFile

    public DefaultDataFile(DataFile object)
    Constructs a new instance initialized with the values from the specified metadata object. This is a shallow copy constructor, because the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the metadata to copy values from, or `null` if none.
    See Also:
      - `castOrCopy(DataFile)`

- ## Method Details

  - ### castOrCopy

    public static DefaultDataFile castOrCopy(DataFile object)
    Returns a SIS metadata implementation with the values of the given arbitrary implementation. This method performs the first applicable action in the following choices:
    - If the given object is `null`, then this method returns `null`.
    - Otherwise if the given object is already an instance of `DefaultDataFile`, then it is returned unchanged.
    - Otherwise a new `DefaultDataFile` instance is created using the copy constructor and returned. Note that this is a shallow copy operation, because the other metadata contained in the given object are not recursively copied.
    Parameters:
      `object` - the object to get as a SIS implementation, or `null` if none.
    Returns:
      a SIS implementation containing the values of the given object (may be the given object itself), or `null` if the argument was null.

  - ### getFileName

    public URI getFileName()
    Returns the name or path of the file.
    Returns:
      file name, or `null`.
    Since:
      1.0
    See Also:
      - `DefaultBrowseGraphic​.getFileName()`

  - ### setFileName

    public void setFileName(URI newValue)
    Sets the name or path of the file.
    Parameters:
      `newValue` - the new filename or path.
    Since:
      1.0

  - ### getFileDescription

    public InternationalString getFileDescription()
    Returns the text description of the file.
    Returns:
      text description of the file, or `null`.
    Since:
      1.0
    See Also:
      - `DefaultBrowseGraphic​.getFileDescription()`

  - ### setFileDescription

    public void setFileDescription(InternationalString newValue)
    Sets the text description of the file.
    Parameters:
      `newValue` - the new file description.
    Since:
      1.0

  - ### getFileType

    public String getFileType()
    Format in which the file is encoded.
    Returns:
      format in which the file is encoded, or `null`.
    Since:
      1.0
    See Also:
      - `DefaultBrowseGraphic​.getFileType()`

  - ### setFileType

    public void setFileType(String newValue)
    Sets the format in which the illustration is encoded. Raster formats are encouraged to use one of the names returned by `ImageIO​.getReaderFormatNames()`.
    Parameters:
      `newValue` - the new file type.

  - ### getFeatureTypes

    public Collection<LocalName> getFeatureTypes()
    Returns the list of feature types concerned by the transfer data file. Depending on the transfer choices, a data file may contain data related to one or many feature types. This attribute may be omitted when the dataset is composed of a single file and/or the data does not relate to a feature catalogue.
    Specified by:
      `getFeatureTypes` in interface `DataFile`
    Returns:
      list of features types concerned by the transfer data file.

  - ### setFeatureTypes

    public void setFeatureTypes(Collection<? extends LocalName> newValues)
    Sets the list of feature types concerned by the transfer data file.
    Parameters:
      `newValues` - the new feature type values.

  - ### getFileFormat

    @Deprecated(since="1.0") public Format getFileFormat()
    Deprecated.
    Removed in latest XSD schemas.
    Returns the format of the transfer data file.
    Specified by:
      `getFileFormat` in interface `DataFile`
    Returns:
      format of the transfer data file, or `null`.

  - ### setFileFormat

    @Deprecated(since="1.0") public void setFileFormat(Format newValue)
    Deprecated.
    Removed in latest XSD schemas.
    Sets the format of the transfer data file.
    Parameters:
      `newValue` - the new file format value.